import json
layout = [
    {"matrix": [0, 3], "x": 3, "y": 0},
    {"matrix": [0, 10], "x": 11, "y": 0},
    {"matrix": [0, 2], "x": 2, "y": 0.125},
    {"matrix": [0, 4], "x": 4, "y": 0.125},
    {"matrix": [0, 5], "x": 5, "y": 0.125},
    {"matrix": [0, 6], "x": 6, "y": 0.125},
    {"matrix": [0, 7], "x": 8, "y": 0.125},
    {"matrix": [0, 8], "x": 9, "y": 0.125},
    {"matrix": [0, 9], "x": 10, "y": 0.125},
    {"matrix": [0, 11], "x": 12, "y": 0.125},
    {"matrix": [1, 3], "x": 3, "y": 1},
    {"matrix": [1, 10], "x": 11, "y": 1},
    {"matrix": [1, 2], "x": 2, "y": 1.125},
    {"matrix": [1, 4], "x": 4, "y": 1.125},
    {"matrix": [1, 5], "x": 5, "y": 1.125},
    {"matrix": [1, 6], "x": 6, "y": 1.125},
    {"matrix": [1, 7], "x": 8, "y": 1.125},
    {"matrix": [1, 8], "x": 9, "y": 1.125},
    {"matrix": [1, 9], "x": 10, "y": 1.125},
    {"matrix": [1, 11], "x": 12, "y": 1.125},
    {"matrix": [1, 0], "x": 0, "y": 1.375},
    {"matrix": [1, 1], "x": 1, "y": 1.375},
    {"matrix": [1, 12], "x": 13, "y": 1.375},
    {"matrix": [1, 13], "x": 14, "y": 1.375},
    {"matrix": [2, 3], "x": 3, "y": 2},
    {"matrix": [2, 10], "x": 11, "y": 2},
    {"matrix": [2, 2], "x": 2, "y": 2.125},
    {"matrix": [2, 4], "x": 4, "y": 2.125},
    {"matrix": [2, 5], "x": 5, "y": 2.125},
    {"matrix": [2, 6], "x": 6, "y": 2.125},
    {"matrix": [2, 7], "x": 8, "y": 2.125},
    {"matrix": [2, 8], "x": 9, "y": 2.125},
    {"matrix": [2, 9], "x": 10, "y": 2.125},
    {"matrix": [2, 11], "x": 12, "y": 2.125},
    {"matrix": [2, 0], "x": 0, "y": 2.375},
    {"matrix": [2, 1], "x": 1, "y": 2.375},
    {"matrix": [2, 12], "x": 13, "y": 2.375},
    {"matrix": [2, 13], "x": 14, "y": 2.375},
    {"matrix": [3, 3], "x": 3, "y": 3},
    {"matrix": [3, 10], "x": 11, "y": 3},
    {"matrix": [3, 2], "x": 2, "y": 3.125},
    {"matrix": [3, 4], "x": 4, "y": 3.125},
    {"matrix": [3, 5], "x": 5, "y": 3.125},
    {"matrix": [3, 6], "x": 6, "y": 3.125},
    {"matrix": [3, 7], "x": 8, "y": 3.125},
    {"matrix": [3, 8], "x": 9, "y": 3.125},
    {"matrix": [3, 9], "x": 10, "y": 3.125},
    {"matrix": [3, 11], "x": 12, "y": 3.125},
    {"matrix": [3, 0], "x": 0, "y": 3.375},
    {"matrix": [3, 1], "x": 1, "y": 3.375},
    {"matrix": [3, 12], "x": 13, "y": 3.375},
    {"matrix": [3, 13], "x": 14, "y": 3.375},
    {"matrix": [4, 3], "x": 3, "y": 4},
    {"matrix": [4, 10], "x": 11, "y": 4},
    {"matrix": [4, 2], "x": 2, "y": 4.125},
    {"matrix": [4, 4], "x": 4, "y": 4.125},
    {"matrix": [4, 5], "x": 5, "y": 4.125},
    {"matrix": [4, 6], "x": 6, "y": 4.125},
    {"matrix": [4, 7], "x": 8, "y": 4.125},
    {"matrix": [4, 8], "x": 9, "y": 4.125},
    {"matrix": [4, 9], "x": 10, "y": 4.125},
    {"matrix": [4, 11], "x": 12, "y": 4.125},
    {"matrix": [4, 0], "x": 0, "y": 4.375},
    {"matrix": [4, 1], "x": 1, "y": 4.375},
    {"matrix": [4, 12], "x": 13, "y": 4.375},
    {"matrix": [4, 13], "x": 14, "y": 4.375},
    {"matrix": [5, 3], "x": 3, "y": 5},
    {"matrix": [5, 10], "x": 11, "y": 5},
    {"matrix": [5, 2], "x": 2, "y": 5.125},
    {"matrix": [5, 4], "x": 4, "y": 5.125},
    {"matrix": [5, 5], "x": 5, "y": 5.125},
    {"matrix": [5, 6], "x": 6, "y": 5.125},
    {"matrix": [5, 7], "x": 8, "y": 5.125},
    {"matrix": [5, 8], "x": 9, "y": 5.125},
    {"matrix": [5, 9], "x": 10, "y": 5.125},
    {"matrix": [5, 11], "x": 12, "y": 5.125},
    {"matrix": [5, 0], "x": 0, "y": 5.375},
    {"matrix": [5, 1], "x": 1, "y": 5.375},
    {"matrix": [5, 12], "x": 13, "y": 5.375},
    {"matrix": [5, 13], "x": 14, "y": 5.375},
]


new_layout = []
for x in layout:
    m = x["matrix"]
    if m[1] > 6:
        m[0] += 6
        m[1] -= 7
    x["matrix"] = m
    new_layout.append(x)

print(json.dumps(new_layout))
