# snappy

![snappy](imgur.com image replace me!)

*A short description of the keyboard/project*

* Keyboard Maintainer: [Philip Gaber](https://github.com/qhga)
* Hardware Supported: *The PCBs, controllers supported*
* Hardware Availability: *Links to where you can find this hardware*

Make example for this keyboard (after setting up your build environment):

    make snappy:default

    # REV1 & REV2 (elite c)
    sudo make snappy/rev1:default:dfu-split-left
    sudo make snappy/rev1:default:dfu-split-right

    sudo make snappy/rev2:default:dfu-split-left
    sudo make snappy/rev2:default:dfu-split-right

    # REV3 (promicro rp2040) (info.json -> CURRENTLY NOT WORKING)
    sudo make snappy/rev3:default:uf2-split-left
    sudo make snappy/rev3:default:uf2-split-right

    # REV3_5 (promicro rp2040) (WITHOUT info.json)
    sudo make snappy/rev3_5:default:uf2-split-left
    sudo make snappy/rev3_5:default:uf2-split-right

    # Make sure to mount the RP2040 drive to /media/snappy for automatic copying of the .uf2 file

See the [build environment setup](https://docs.qmk.fm/#/getting_started_build_tools) and the [make instructions](https://docs.qmk.fm/#/getting_started_make_guide) for more information. Brand new to QMK? Start with our [Complete Newbs Guide](https://docs.qmk.fm/#/newbs).

## Bootloader

Enter the bootloader in 3 ways:

### REV1 & REV2
* **Physical Reset Button**: Briefly press the button on the back of the PCB - some may have pads you must short instead
* **Keycode in Layout**: Press the key mapped to `QK_BOOT` (REV1 & REV2) if it is available

### REV3 (NOT WORKING) & REV3_5
* **Physical Reset Button**: Hold the `boot` button while plugging in the MC OR hold `boot` and press `reset`
* **Physical Bootmagic Key**: Hold the `boot` button while plugging in the MC OR hold `boot` and press `reset`
* **Keycode in Layout**: Press the key mapped to `QK_BOOT` (REV3 & REV3_5) if it is available

info.json spec: https://github.com/qmk/qmk_firmware/blob/master/docs/reference_info_json.md

### VIA (Troubleshooting)

On GNU/Linux while using Chrome to access VIA (https://usevia.app/)
Navigate to `chrome://device-log` find hidrawXYZ

    sudo chown $USER:$USER /dev/hidrawXYZ

For now we have to upload the `snappy_revXYZ_via_keyboard_definition.json` located in the `/etc/` folder manually to the via website